{ Uzivatelske rozhrani ke hre Boulder Man }
unit Unit1;

interface

uses
  VMFiles, BMBase, FMXUtils,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, Buttons, IBCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    function FindProf(S: string; var Level: integer): integer;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}
{$I BMCOMMIM.INC} // nahravani map

const
   ASTEPS = 4; // pocet animaci na 1 tah
   ICS = 24;   // ctvercovy rozmer ikonek
   SICS = 16;  // ctvercovy rozmer cislic
   IC = 6 ;    // velikost posunu ICS / ASTEPS
   // implicitni rozmery vystupni bitmapy (360x240)
   ICX = 15;  ICY = 10;  // v ikonkach

   fPICT    = 'BMPICT.BMP';
   fICONS   = 'BMICONS.BMP';
   fPROFILS = 'BMPLAYER.LST';
   fHELP    = '..\DOC\BMAN.HTML';
   msgCHPLAYER = 'Volba hre';
   msgPAUSE    = 'Pauza';
   msgRUN      = 'Spustit hru';
   msgCONTINUE = 'Pokraovat ve he';
   msgCLICK    = 'Klikni nebo stiskni klvesu pro menu';

type TIPos = array [0..1] of integer; // 0,1: pozice X, Y
     TAPos = array [1..ASTEPS, 0..1] of integer; // 0,1: pozice
     TAnim = array [1..ASTEPS, 0..3] of integer; // 0,1: pozice, 2,3: posun

const // mapovani animacnich ikonek v SrcBM (resp. BMICONS.BMP)
   // s nedefinovanou animaci
   iMEZERA: TIPos = (0*ICS,0*ICS);
   iTRAVA : TIPos = (0*ICS,1*ICS);
   iZEDS  : TIPos = (3*ICS,1*ICS);
   iZEDN  : TIPos = (4*ICS,1*ICS);
   zVYCHOD: TIPos = (4*ICS,3*ICS);
   oVYCHOD: TIPos = (5*ICS,3*ICS);
   iKAMEN : TIPos = (0*ICS,3*ICS);
   iDIAM  : TIPos = (0*ICS,2*ICS);
   iTRHAV : TIPos = (0*ICS,4*ICS);
   iHRAC  : TIPos = (3*ICS,5*ICS);
   iPRISER: TIPos = (1*ICS,7*ICS);
   // animovane bez posunu
   evExpld: TAPos =((1*ICS,0*ICS), (2*ICS,0*ICS),
                    (3*ICS,0*ICS), (4*ICS,0*ICS));
   suTRAVA: TAPos =((1*ICS,1*ICS), (2*ICS,1*ICS),
                    (0*ICS,0*ICS), (0*ICS,0*ICS));
   suDIAM : TAPos =((1*ICS,2*ICS), (2*ICS,2*ICS),
                    (0*ICS,0*ICS), (0*ICS,0*ICS));
   inTRHAV: TAPos =((4*ICS,4*ICS), (3*ICS,4*ICS),
                    (1*ICS,4*ICS), (2*ICS,4*ICS));
   eiHRAC: TAPos = ((3*ICS,5*ICS), (7*ICS,5*ICS),
                    (7*ICS,7*ICS), (0*ICS,0*ICS));
   // animovane s posunem
   fdTRHAV : TAnim =((1*ICS,4*ICS, 0*IC,+1*IC), (2*ICS,4*ICS, 0*IC,+2*IC),
                     (1*ICS,4*ICS, 0*IC,+3*IC), (2*ICS,4*ICS, 0*IC,+4*IC));
   mlTRHAV : TAnim =((0*ICS,4*ICS,-1*IC, 0*IC), (0*ICS,4*ICS,-2*IC, 0*IC),
                     (0*ICS,4*ICS,-3*IC, 0*IC), (0*ICS,4*ICS,-4*IC, 0*IC));
   mrTRHAV : TAnim =((0*ICS,4*ICS,+1*IC, 0*IC), (0*ICS,4*ICS,+2*IC, 0*IC),
                     (0*ICS,4*ICS,+3*IC, 0*IC), (0*ICS,4*ICS,+4*IC, 0*IC));
   fdKAMEN : TAnim =((0*ICS,3*ICS, 0*IC,+1*IC), (0*ICS,3*ICS, 0*IC,+2*IC),
                     (0*ICS,3*ICS, 0*IC,+3*IC), (0*ICS,3*ICS, 0*IC,+4*IC));
   mlKAMEN : TAnim =((3*ICS,3*ICS,-1*IC, 0*IC), (2*ICS,3*ICS,-2*IC, 0*IC),
                     (1*ICS,3*ICS,-3*IC, 0*IC), (0*ICS,3*ICS,-4*IC, 0*IC));
   mrKAMEN : TAnim =((1*ICS,3*ICS,+1*IC, 0*IC), (2*ICS,3*ICS,+2*IC, 0*IC),
                     (3*ICS,3*ICS,+3*IC, 0*IC), (0*ICS,3*ICS,+4*IC, 0*IC));
   flKAMEN : TAnim =((3*ICS,3*ICS,-1*IC, 0*IC), (2*ICS,3*ICS,-2*IC,+1*IC),
                     (1*ICS,3*ICS,-3*IC,  +15), (0*ICS,3*ICS,-4*IC,+4*IC));
   frKAMEN : TAnim =((1*ICS,3*ICS,+1*IC, 0*IC), (2*ICS,3*ICS,+2*IC,+1*IC),
                     (3*ICS,3*ICS,+3*IC,  +15), (0*ICS,3*ICS,+4*IC,+4*IC));
   fdDIAM  : TAnim =((0*ICS,2*ICS, 0*IC,+1*IC), (0*ICS,2*ICS, 0*IC,+2*IC),
                     (0*ICS,2*ICS, 0*IC,+3*IC), (0*ICS,2*ICS, 0*IC,+4*IC));
   flDIAM  : TAnim =((5*ICS,2*ICS,-1*IC, 0*IC), (4*ICS,2*ICS,-2*IC,+1*IC),
                     (3*ICS,2*ICS,-3*IC,  +15), (0*ICS,2*ICS,-4*IC,+4*IC));
   frDIAM  : TAnim =((0*ICS,2*ICS,+1*IC, 0*IC), (3*ICS,2*ICS,+2*IC,+1*IC),
                     (4*ICS,2*ICS,+3*IC,  +15), (5*ICS,2*ICS,+4*IC,+4*IC));
   mlHRAC  : TAnim =((7*ICS,6*ICS,-1*IC, 0*IC), (6*ICS,6*ICS,-2*IC, 0*IC),
                     (5*ICS,6*ICS,-3*IC, 0*IC), (4*ICS,6*ICS,-4*IC, 0*IC));
   mrHRAC  : TAnim =((0*ICS,6*ICS,+1*IC, 0*IC), (1*ICS,6*ICS,+2*IC, 0*IC),
                     (2*ICS,6*ICS,+3*IC, 0*IC), (3*ICS,6*ICS,+4*IC, 0*IC));
   muHRAC  : TAnim =((5*ICS,5*ICS, 0*IC,-1*IC), (6*ICS,5*ICS, 0*IC,-2*IC),
                     (6*ICS,5*ICS, 0*IC,-3*IC), (4*ICS,5*ICS, 0*IC,-4*IC));
   mdHRAC  : TAnim =((1*ICS,5*ICS, 0*IC,+1*IC), (0*ICS,5*ICS, 0*IC,+2*IC),
                     (2*ICS,5*ICS, 0*IC,+3*IC), (0*ICS,5*ICS, 0*IC,+4*IC));
   mlPRISER: TAnim =((4*ICS,7*ICS,-1*IC, 0*IC), (1*ICS,7*ICS,-2*IC, 0*IC),
                     (4*ICS,7*ICS,-3*IC, 0*IC), (0*ICS,7*ICS,-4*IC, 0*IC));
   mrPRISER: TAnim =((3*ICS,7*ICS,+1*IC, 0*IC), (1*ICS,7*ICS,+2*IC, 0*IC),
                     (3*ICS,7*ICS,+3*IC, 0*IC), (0*ICS,7*ICS,+4*IC, 0*IC));
   muPRISER: TAnim =((5*ICS,7*ICS, 0*IC,-1*IC), (6*ICS,7*ICS, 0*IC,-2*IC),
                     (5*ICS,7*ICS, 0*IC,-3*IC), (6*ICS,7*ICS, 0*IC,-4*IC));
   mdPRISER: TAnim =((0*ICS,7*ICS, 0*IC,+1*IC), (2*ICS,7*ICS, 0*IC,+2*IC),
                     (0*ICS,7*ICS, 0*IC,+3*IC), (2*ICS,7*ICS, 0*IC,+4*IC));

   iNums : array [-1..9] of TIPos = ( // 0..9 cislice, -1..diamantik
      (6*ICS,0*SICS),(6*ICS+1*SICS,0*SICS),(6*ICS+2*SICS,0*SICS),
      (6*ICS,1*SICS),(6*ICS+1*SICS,1*SICS),(6*ICS+2*SICS,1*SICS),
      (6*ICS,2*SICS),(6*ICS+1*SICS,2*SICS),(6*ICS+2*SICS,2*SICS),
      (6*ICS,3*SICS),(6*ICS+1*SICS,3*SICS));

var OutBM, SrcBM: TBitmap;     // vystupni, zdrojova bitmapa
    GState, AState: integer;   // stav hry, stav animaci
    SuckUp, EndLevel: boolean; // priznak vysati, ukonceni levelu
    Move: byte;                // budouci a minuly pohyb hrace

    OM: TMap;       // mapa objektu hry
    BME: TBMEvents; // udalosti v mape

function ICSRect(X, Y: integer): TRect;  // pomocna
begin
   Result.Left:= X;
   Result.Top:= Y;
   Result.Right:= X + ICS;
   Result.Bottom:= Y + ICS;
end;


function AnimRect(Obj, Ev, AStep: integer; var MvX, MvY: integer): TRect;
{ Vraci souradnice animovane ikonky (ze SrcBM) podle objeku a kroku animace a
  v MvX a MvY jeji posunuti  }
begin
   MvX:= 0;  MvY:= 0;
   case Obj of
      MEZERA: case Ev of
         eEXPL, eDEXPL: Result:= ICSRect(evExpld[AStep, 0], evExpld[AStep, 1]);
         else Result:= ICSRect(iMEZERA[0], iMEZERA[1]); end;
      TRAVA: case Ev of
         eEXPL, eDEXPL: Result:= ICSRect(evExpld[AStep, 0], evExpld[AStep, 1]);
         eSUCK        : Result:= ICSRect(suTRAVA[AStep, 0], suTRAVA[AStep, 1]);
         else Result:= ICSRect(iTRAVA[0], iTRAVA[1]); end;

      ZEDS: Result:= ICSRect(iZEDS[0], iZEDS[1]);
      ZEDN: case Ev of
         eEXPL, eDEXPL: Result:= ICSRect(evExpld[AStep, 0], evExpld[AStep, 1]);
         else Result:= ICSRect(iZEDN[0], iZEDN[1]); end;
      VYCHOD: case Ev of
         eEXPL, eDEXPL: Result:= ICSRect(evExpld[AStep, 0], evExpld[AStep, 1]);
         eINIT: Result:= ICSRect(oVYCHOD[0], oVYCHOD[1]);
         else Result:= ICSRect(zVYCHOD[0], zVYCHOD[1]); end;

      TRHAVINA: case Ev of
         eEXPL, eDEXPL: Result:= ICSRect(evExpld[AStep, 0], evExpld[AStep, 1]);
         eINIT: Result:= ICSRect(inTRHAV[AStep, 0], inTRHAV[AStep, 1]);
         eMVL: begin MvX:= mlTRHAV[AStep, 2];  MvY:= mlTRHAV[AStep, 3];
                     Result:= ICSRect(mlTRHAV[AStep, 0], mlTRHAV[AStep, 1]);
                     end;
         eMVR: begin MvX:= mrTRHAV[AStep, 2];  MvY:= mrTRHAV[AStep, 3];
                     Result:= ICSRect(mrTRHAV[AStep, 0], mrTRHAV[AStep, 1]);
                     end;
         eFALLD: begin MvX:= fdTRHAV[AStep, 2];  MvY:= fdTRHAV[AStep, 3];
                       Result:= ICSRect(fdTRHAV[AStep, 0], fdTRHAV[AStep, 1]);
                       end
         else Result:= ICSRect(iTRHAV[0], iTRHAV[1]);
         end;

      KAMEN: case Ev of
         eEXPL, eDEXPL: Result:= ICSRect(evExpld[AStep, 0], evExpld[AStep, 1]);
         eMVL: begin MvX:= mlKAMEN[AStep, 2];  MvY:= mlKAMEN[AStep, 3];
                     Result:= ICSRect(mlKAMEN[AStep, 0], mlKAMEN[AStep, 1]);
                     end;
         eMVR: begin MvX:= mrKAMEN[AStep, 2];  MvY:= mrKAMEN[AStep, 3];
                     Result:= ICSRect(mrKAMEN[AStep, 0], mrKAMEN[AStep, 1]);
                     end;
         eFALLL: begin MvX:= flKAMEN[AStep, 2];  MvY:= flKAMEN[AStep, 3];
                       Result:= ICSRect(flKAMEN[AStep, 0], flKAMEN[AStep, 1]);
                       end;
         eFALLR: begin MvX:= frKAMEN[AStep, 2];  MvY:= frKAMEN[AStep, 3];
                       Result:= ICSRect(frKAMEN[AStep, 0], frKAMEN[AStep, 1]);
                       end;
         eFALLD: begin MvX:= fdKAMEN[AStep, 2];  MvY:= fdKAMEN[AStep, 3];
                       Result:= ICSRect(fdKAMEN[AStep, 0], fdKAMEN[AStep, 1]);
                       end;
         else Result:= ICSRect(iKAMEN[0], iKAMEN[1]);
         end;

      DIAMANT: case Ev of
         eEXPL, eDEXPL: Result:= ICSRect(evExpld[AStep, 0], evExpld[AStep, 1]);
         eFALLL: begin MvX:= flDIAM[AStep, 2];  MvY:= flDIAM[AStep, 3];
                       Result:= ICSRect(flDIAM[AStep, 0], flDIAM[AStep, 1]);
                       end;
         eFALLR: begin MvX:= frDIAM[AStep, 2];  MvY:= frDIAM[AStep, 3];
                       Result:= ICSRect(frDIAM[AStep, 0], frDIAM[AStep, 1]);
                       end;
         eFALLD: begin MvX:= fdDIAM[AStep, 2];  MvY:= fdDIAM[AStep, 3];
                       Result:= ICSRect(fdDIAM[AStep, 0], fdDIAM[AStep, 1]);
                       end;
         eSUCK: Result:= ICSRect(suDIAM[AStep, 0], suDIAM[AStep, 1]);
         else Result:= ICSRect(iDIAM[0], iDIAM[1]);
         end;

      HRAC: case Ev of
         eEXPL, eDEXPL: Result:= ICSRect(evExpld[AStep, 0], evExpld[AStep, 1]);
         eMVL: begin MvX:= mlHRAC[AStep, 2];  MvY:= mlHRAC[AStep, 3];
                     Result:= ICSRect(mlHRAC[AStep, 0], mlHRAC[AStep, 1]);
                     end;
         eMVR: begin MvX:= mrHRAC[AStep, 2];  MvY:= mrHRAC[AStep, 3];
                     Result:= ICSRect(mrHRAC[AStep, 0], mrHRAC[AStep, 1]);
                     end;
         eMVU: begin MvX:= muHRAC[AStep, 2];  MvY:= muHRAC[AStep, 3];
                     Result:= ICSRect(muHRAC[AStep, 0], muHRAC[AStep, 1]);
                     end;
         eMVD: begin MvX:= mdHRAC[AStep, 2];  MvY:= mdHRAC[AStep, 3];
                     Result:= ICSRect(mdHRAC[AStep, 0], mdHRAC[AStep, 1]);
                     end;
         else if BME.R.rKONEC
                 then Result:= ICSRect(eiHRAC[AStep, 0], eiHRAC[AStep, 1])
                 else Result:= ICSRect(iHRAC[0], iHRAC[1]);
         end;
      PRISERA: case Ev of
         eEXPL, eDEXPL: Result:= ICSRect(evExpld[AStep, 0], evExpld[AStep, 1]);
         eMVL: begin MvX:= mlPRISER[AStep, 2];  MvY:= mlPRISER[AStep, 3];
                     Result:= ICSRect(mlPRISER[AStep, 0], mlPRISER[AStep, 1]);
                     end;
         eMVR: begin MvX:= mrPRISER[AStep, 2];  MvY:= mrPRISER[AStep, 3];
                     Result:= ICSRect(mrPRISER[AStep, 0], mrPRISER[AStep, 1]);
                     end;
         eMVU: begin MvX:= muPRISER[AStep, 2];  MvY:= muPRISER[AStep, 3];
                     Result:= ICSRect(muPRISER[AStep, 0], muPRISER[AStep, 1]);
                     end;
         eMVD: begin MvX:= mdPRISER[AStep, 2];  MvY:= mdPRISER[AStep, 3];
                     Result:= ICSRect(mdPRISER[AStep, 0], mdPRISER[AStep, 1]);
                     end;
         else Result:= ICSRect(iPRISER[0], iPRISER[1]);
         end;
      end; //case
end;


procedure ScrollCheck(AStep: integer; var X1, Y1, X2, Y2, XS, YS: integer);
{ Kontroluje scrollovani. X1, Y1, X2, Y2 vraci rozmer okna z OM (EM), potrebny
  k nacteni (pri scrollingu se musi cist o 1 redek/sloupec vic). XS, YS vraci
  posun sceny na osach X, Y pri scrollovani - levy dolni roh }
var i1, j1, i2, j2,
    mx1, mx2, my1, my2: integer;  // mozne az 4 stredy sceny
begin
   i1:= 0;  j1:= 0;  i2:= 0;  j2:= 0;
   // najde stredy sceny
   mx1:= (1 + ICX) div 2;  mx2:= mx1 + (1 + ICX) mod 2;
   my1:= (1 + ICY) div 2;  my2:= my1 + (1 + ICY) mod 2;
   // hrac na (levy horni) stred
   X1:= BME.P.PosX - mx1 + 1;
   Y1:= BME.P.PosY - my1 + 1;
   if not BME.P.SuckUp then
      case BME.EM.M[BME.P.PosX, BME.P.PosY] of // pohyb na pozici hrace
         eMVL: i1:= -1;  eMVR: i2:= +1;
         eMVU: j1:= -1;  eMVD: j2:= +1;
         end;
   // kontola okraju sceny, ruseni scrollingu pri pohybu k okrajum
   if X1 + ICX - 1 + i2 > OM.SizeX then
      begin X1:= OM.SizeX - ICX + 1;  i2:= 0; end;
   if (X1 + i1 < 1) or (ICX >= OM.SizeX) then begin X1:= 1;  i1:= 0; end;
   if Y1 + ICY - 1 + j2 > OM.SizeY then
      begin Y1:= OM.SizeY - ICY + 1;  j2:= 0; end;
   if (Y1 + j1 < 1) or (ICY >= OM.SizeY) then begin Y1:= 1;  j1:= 0; end;
   // ruseni scrollingu pri pohybu od okraju (scroling az od stredu sceny)
   if (i1 = -1) and (OM.SizeX - BME.P.PosX + 1 < mx2) then i1:= 0; // zprava
   if (i2 = +1) and (BME.P.PosX < mx1) then i2:= 0; // zleva
   if (j1 = -1) and (OM.SizeY - BME.P.PosY + 1 < my2) then j1:= 0; // zdola
   if (j2 = +1) and (BME.P.PosY < my1) then j2:= 0; // shora
   // dodefinovani vystupu
   X2:= X1 + ICX - 1 + i2;  X1:= X1 + i1;
   Y2:= Y1 + ICY - 1 + j2;  Y1:= Y1 + j1;
   // nastaveni posunu sceny (2 zpusoby, protoze scena se vekresluje LD->RU)
   if (i1 + j1) = 0 then begin // scrolling (opacne nez hrac) doleva/nahoru
      XS:= -i2 * IC * AStep;
      YS:= -j2 * IC * AStep + (Y2 - Y1) * ICS;
      end else begin // vpravo/dolu (kresli o ikonku vic vlevo)
      XS:= -i1 * (IC * AStep - ICS);
      YS:= -j1 * (IC * AStep - ICS) + (Y2 - Y1) * ICS;
      end;
end;


function ClearLocked(i, j: integer; Ev: byte): boolean;
{ Maze pozadi udalosti od vsech pohyblivych objektu (ruseni stinu od pohybu a
  scrolovani) mimo hrace, ktery je resen az nakonec zvlast. Zajistuje ze se
  nakonec preklesli cela stara scena. Funkce vraci TRUE pokud se objekt
  pohybuje }
var R: TRect;  aux: integer;
   procedure ClearDraw(di, dj: integer);
   begin OutBM.Canvas.CopyRect(ICSRect(i + di, j + dj), SrcBM.Canvas, R); end;
begin
   ClearLocked:= TRUE;
   R:= AnimRect(MEZERA, eNOTHING, 0, aux, aux);
   case Ev of
      eMVL: begin ClearDraw(0, 0);  ClearDraw(-ICS, 0); end;
      eMVR: begin ClearDraw(0, 0);  ClearDraw( ICS, 0); end;
      eMVD, eFALLD: begin ClearDraw(0, 0);  ClearDraw(0, ICS); end;
      eMVU: begin ClearDraw(0, 0);  ClearDraw(0, -ICS); end;
      eFALLL: begin
         ClearDraw(0, 0);  ClearDraw(-ICS, 0);  ClearDraw(-ICS, ICS); end;
      eFALLR: begin
         ClearDraw(0, 0);  ClearDraw( ICS, 0 );  ClearDraw(ICS, ICS); end;
      else ClearLocked:= FALSE;
      end;
end;


procedure DrawPlayer(AStep, i, j: integer);
{ Maze pozadi udalosti od hrace a kresli hrace }
var R2: TRect; a, b, aux: integer;
begin
   with BME do begin
      R2:= AnimRect(HRAC, EM.M[P.PosX, P.PosY], AStep, a, b);
      case EM.M[P.PosX, P.PosY] of
         eMVL, eMVR, eMVD, eMVU:
            if P.SuckUp then begin a:= 0; b:= 0; end
            else OutBM.Canvas.CopyRect(ICSRect(i, j), SrcBM.Canvas,
                    AnimRect(MEZERA, eNOTHING, 0, aux, aux) );
         end;

      OutBM.Canvas.CopyRect(ICSRect(i + a, j + b), SrcBM.Canvas, R2);
      end;
end;


procedure DrawItem(i, j: integer; AStep, obj, ev: byte);
{ pomocna, kresli ikonku bud normalne nebo bez okraju prekryvanim  }
var a, b: integer; // posun pohybu
    R: TRect;
begin
   R:= AnimRect(obj, ev, AStep, a, b);
   if ClearLocked(i, j, ev) then OutBM.Canvas.CopyMode:= cmSrcPaint;
   OutBM.Canvas.CopyRect(ICSRect(i + a, j + b), SrcBM.Canvas, R);
   OutBM.Canvas.CopyMode:= cmSrcCopy; // nastavi puvodni
end;


procedure DrawBorderLocked(AStep, i, j, x1, y1, x2, y2: integer);
{ Opravi prazna mista na krajich sceny, vznikla priznakem eLOCK od
   pohybliveho objektu mimo scenu, ktery do ni vstupuje }
var a, b, ev, n: integer;
begin
   if x2 > OM.SizeX then x2:= OM.SizeX; // osetri malou mapu
   if y2 > OM.SizeY then y2:= OM.SizeY;
   if y1 - 1 > 1 then begin // radek nad scenou
      a:= i;  b:= j;
      for n:= x1 to x2 do begin
         ev:= BME.EM.M[n, y1 - 1];
         if (ev = eFALLD) or (ev = eFALLL) or (ev = eFALLR) or (ev = eMVD)
            then DrawItem(a, b, AStep, OM.M[n, y1 - 1], ev);
         a:= a + ICS;
         end;
      end;
   if y2 + 1 < OM.SizeY then begin // radek pod scenou
      a:= i;  b:= j + (y2 - y1 + 2) * ICS;
      for n:= x1 to x2 do begin
         ev:= BME.EM.M[n, y2 + 1];
         if ev = eMVU
            then DrawItem(a, b, AStep, OM.M[n, y2 + 1], ev);
         a:= a + ICS;
         end;
      end;
   if x1 - 1 > 1 then begin // sloupec vlevo od sceny
      a:= i - ICS;  b:= j + ICS;
      for n:= y1 to y2 do begin
         ev:= BME.EM.M[x1 - 1, n];
         if (ev = eFALLR) or (ev = eMVR)
            then DrawItem(a, b, AStep, OM.M[x1 - 1, n], ev);
         b:= b + ICS;
         end;
      end;
   if x2 + 1 < OM.SizeX then begin // sloupec vpravo od sceny
      a:= i + (x2 - x1 + 1) * ICS;  b:= j + ICS;
      for n:= y1 to y2 do begin
         ev:= BME.EM.M[x2 + 1, n];
         if (ev = eFALLL) or (ev = eMVL)
            then DrawItem(a, b, AStep, OM.M[x2 + 1, n], ev);
         b:= b + ICS;
         end;
      end;
end;

procedure DrawDiamCnt(i, j, Dcnt: integer);
{ Tiskne pocet potrebnych diamantu k ukonceni kola }
var s: string[4];
    n: byte;
   function SICSRect(X, Y: integer): TRect;  // pomocna
   begin Result.Left:= X;  Result.Right:= X + SICS;
         Result.Top:= Y;   Result.Bottom:= Y + SICS; end;
begin
   if Dcnt > 0 then begin
     str(Dcnt, s);
     OutBM.Canvas.CopyRect(SICSRect(i, j), SrcBM.Canvas, // diamantik
                           SICSRect(iNums[-1, 0], iNums[-1, 1]));
     for n:= 1 to length(s) do                           // cislice
        OutBM.Canvas.CopyRect(SICSRect(i + n * SICS, j), SrcBM.Canvas,
           SICSRect(iNums[StrToInt(s[n]), 0], iNums[StrToInt(s[n]), 1]));
     end;
end;

procedure DrawScene(AStep: integer);
{ Vykresli scenu v danem animacnim kroku AStep }
var x, y,               // pozice v OM mape
    i, j, pi, pj,       // souradnice na OutMB bitmape
    x1, y1, x2, y2, XS, // scrolling
    aux: integer;
begin
   ScrollCheck(Astep, x1, y1, x2, y2, XS, j);
   for y:= y2 downto y1 do begin
      i:= XS;
      for x:= x1 to x2 do begin
         if (x > OM.SizeX) or (y > OM.SizeY)
            then OutBM.Canvas.CopyRect(ICSRect(i, j), SrcBM.Canvas,
                    AnimRect(ZEDS, eNOTHING, 0, aux, aux))
            else if (x = BME.P.PosX) and (y = BME.P.PosY) and BME.P.Exist
               then begin pi:= i;  pj:= j; end
               else if (BME.EM.M[x, y] <> eLOCK) then begin
                       ClearLocked(i, j, BME.EM.M[x, y]);
                       DrawItem(i, j, AStep, OM.M[x, y], BME.EM.M[x, y]);
                       end;
         i:= i + ICS;
         end;
      j:= j - ICS;
      end;
   // dokreleni objektu vstupujicich do sceny
   DrawBorderLocked(Astep, XS, j, x1, y1, x2, y2);
   // pi, pj budou vzdy definovane diky ScrollCheck (hrac je vzdy ve scene)
   if BME.P.Exist then DrawPlayer(Astep, pi, pj); // kresli hrace nakonec
   // tisk poctu diamantu
   DrawDiamCnt(0, OutBM.Height - SICS, BME.E.DCnt - BME.P.DCnt);
end;


procedure AnimSceneChange(var ChState: integer; DrawMap: boolean);
{ Animovana zmena OutBM sceny. Pokud je DrawMap TRUE, vykresluje se mapa
  (v SrcBM musi byt bitmapa ikonek) podle OM (musi mit definovane hodnoty),
  jinak (v SrcBM musi byt bitmapa pozadi) vykresluje pozadi. ChState udava stav
  zmeny. Pred zacatkem animace musi byt ChState 0, pak uz hodnotu meni sama
  funkce. Funkce vraci v ChState -1 pokud provedla posledni animaci. }
var x, y, n,
    x1, y1, x2, y2, aux, // animace spravne casti mapy
    j: integer;          // misto nasobeni
begin
   j:= 0;
   ScrollCheck(1, x1, y1, x2, y2, aux, aux);
   for y:= y1 to y2 do begin
      // posun puvodniho pozadi
      if odd(y) then begin
         x:= ChState + 1;
         for n:= ICX downto x do
            OutBM.Canvas.CopyRect(ICSRect((n - 1) * ICS, j), OutBM.Canvas,
                                  ICSRect((n - 2) * ICS, j));
         end else begin
         x:= ICX - ChState;
         for n:= 1 to x do
            OutBM.Canvas.CopyRect(ICSRect((n - 1) * ICS, j), OutBM.Canvas,
                                  ICSRect(n * ICS, j));
         end;
      // kresleni ikonek
      if DrawMap then // mapy
         if (x > OM.SizeX) or (y > OM.SizeY)
            then OutBM.Canvas.CopyRect(ICSRect((x - 1) * ICS, j), SrcBM.Canvas,
                    AnimRect(ZEDS, eNOTHING, 0, aux, aux))
            else OutBM.Canvas.CopyRect(ICSRect((x - 1) * ICS, j), SrcBM.Canvas,
                    AnimRect(OM.M[x + x1 - 1, y], eNOTHING, 0, aux, aux))
      else OutBM.Canvas.CopyRect(ICSRect((x - 1) * ICS, j), SrcBM.Canvas,
                                 ICSRect((x - 1) * ICS, j));  // pozadi
      j:= j + ICS;
      end;
   if ChState = ICX - 1 then ChState:= -1 else ChState:= ChState + 1;
end;



procedure LoadBitmap(fName: string; var BM: TBitmap);
begin
   try BM.LoadFromFile(fName);
       BM.Width:= ICX * ICS;  BM.Height:= ICY * ICS;
       BM.IgnorePalette:= TRUE;
   except MessageDlg('Cannot open bitmap file ' + fName, mtError, [mbOk], 0);
          halt(1);
          end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   VFInit;  // inicializace VP pro blokova nacitani map
   ClientWidth:= ICX * ICS;
   ClientHeight:= ICY * ICS;
   try SrcBM:= TBitmap.Create;
       OutBM:= TBitmap.Create;
   except MessageDlg('Cannot create bitmaps', mtError, [mbOk], 0);
          halt(1);
          end;
   LoadBitmap(fPICT, OutBM);
   try ComboBox1.Items.LoadFromFile(fPROFILS); except end;
   GState:= 0; // stav START
   EndLevel:= FALSE;
   Timer1.Enabled:= TRUE;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
   SrcBM.Free;
   OutBM.Free;
end;


procedure TForm1.FormPaint(Sender: TObject);
begin
   Canvas.Draw(0,0, OutBM);
end;


function SetProf(S: string; i: integer): string;
{ prevede jmeno hrace S a uroven i (1-99) na format profilu }
begin
   SetProf:= S + ' (level ' + copy(IntToStr(100 + i), 2, 2) + ')';
end;

function GetProf(S: string; var i: integer): string;
{ prevede profil hrace S na uroven i (1-99) a na format jmena i vraci -1,
  pokud S neni profil }
var err: integer;
begin
   val(copy(S, length(S) - 2, 2), i, err);
   if err = 0 then GetProf:= copy(S, 1, length(S) - 11)
              else begin i:= -1;  GetProf:= S; end;
end;


function TForm1.FindProf(S: string; var Level: integer): integer;
{ Hleda jmeno hrace S v profilech ComboBox1.Items. V Level vraci uroven hrace.
  Funkce vraci index prvni nalezene polozky, nebo -1 (a nedefinovany Level),
  pokud ji nenajde }
var i: integer;  found: boolean;
begin
   i:= 0;
   S:= GetProf(S, Level); // prevede pripadny vstupni profil na jmeno
   found:= S = '';        // nehleda prazny retezec
   while not found and (i < ComboBox1.Items.Count) do begin
      found:= GetProf(ComboBox1.Items[i], Level) = S;
      i:= i + 1;
      end;
   if Found then Result:= i - 1 else Result:= -1;
end;


procedure TForm1.BitBtn1Click(Sender: TObject); // tl. hrat
var S: string;
    level: integer;
begin
   if not BitBtn3.Enabled and (GState = 0) then begin // novy profil hrace
      S:= SetProf(ComboBox1.Text, 1);
      ComboBox1.Items.Add(S);
      try ComboBox1.Items.SaveToFile(fPROFILS); except end;
      ComboBox1.Text:= S;
      BitBtn3.Enabled:= TRUE;
      end;
   if GState = 0 then begin // nahrani mapy
      GetProf(ComboBox1.Text, level);
      S:= 'LEVEL' + copy(IntToStr(100 + level), 2, 2) + '.MAP';
      if LoadMap(S, OM) = LMNoErr then begin
          LoadBitmap(fICONS, SrcBM);
          InitBMEvents(BME, OM, 0);
          GState:= 1;
          Timer1.Enabled:= TRUE;
          end
      else MessageDlg('Cannot open map file ' + S, mtWarning, [mbOk], 0);
      end else begin ComboBox1.Enabled:= TRUE;
                     BitBtn3.Enabled:= TRUE;
                     Timer1.Enabled:= TRUE;
                     end;
   Panel1.Visible:= FALSE;
end;


procedure TForm1.BitBtn3Click(Sender: TObject); //tl. samaz profil
var i, aux: integer;
begin
   i:= FindProf(ComboBox1.Text, aux);
   if i <> -1 then begin ComboBox1.Items.Delete(i);
                         try ComboBox1.Items.SaveToFile(fPROFILS); except end;
                         end;
   BitBtn3.Enabled:= FALSE;
   BitBtn1.Enabled:= FALSE;
   ComboBox1.Text:= '';
   ActiveControl:= ComboBox1;
end;


procedure TForm1.ComboBox1Change(Sender: TObject);
{ automaticke vyhledavani profilu }
var i, aux: integer;
begin
   ComboBox1.Text:= GetProf(ComboBox1.Text, aux);
   i:= FindProf(ComboBox1.Text, aux);
   if i <> -1 then begin
      BitBtn3.Enabled:= TRUE;
      ComboBox1.Text:= ComboBox1.Items[i];
      end else BitBtn3.Enabled:= FALSE;
   BitBtn1.Enabled:= ComboBox1.Text <> '';
end;



procedure TForm1.Timer1Timer(Sender: TObject); // hra
var n, level: integer;
    S: string;
begin
   case GState of
      0: begin // uvodni cekani nebo autom. zobrazeni panelu po ukonceni levelu
         AState:= 0;  Move:= eNOTHING;
         Timer1.Enabled:= FALSE;
         Canvas.Draw(0,0, OutBM);
         if EndLevel then begin // aktualizace profilu na dalsi level
            Panel1.Visible:= TRUE;
            S:= GetProf(ComboBox1.Text, level);       // upravi profil
            S:= SetProf(S, level + 1);
            ComboBox1.Items.Add(S);                   // vlozi novy
            n:= FindProf(ComboBox1.Text, level);      // vyhleda stary
            if n > -1 then ComboBox1.Items.Delete(n); // smaze stary
            ComboBox1.Text:= S;
            try ComboBox1.Items.SaveToFile(fPROFILS); except end;
            end else Hint:= msgCLICK;
         end;
      1: begin // animovana zmena sceny na hru
         AnimSceneChange(AState, TRUE);
         Canvas.Draw(0,0, OutBM);
         if AState = -1 then begin GState:= 2;  AState:= 1; end;
         end;
      2: begin // vlastni hra
         DrawScene(AState);
         Canvas.Draw(0,0, OutBM);
         if AState = ASTEPS then begin
            if BME.P.Exist then AState:= 0 else begin
               GState:= 3;  AState:= -1; // konnec hry pri neexistenci hrace
               EndLevel:= BME.R.rKONEC;
               Timer1.Enabled:= FALSE;
               LoadBitmap(fPICT, SrcBM); // nahraje pozadi
               Timer1.Enabled:= TRUE;
               end;
            UpdateMap(BME, OM);                  // vola ADT
            UpdateEvents(BME, OM, Move, SuckUp);
            Move:= eNOTHING;
            end;
         AState:= AState + 1;
         end;
      3: begin // animovana zmena sceny na cernou
         AnimSceneChange(AState, FALSE);
         Canvas.Draw(0,0, OutBM);
         if AState = -1 then GState:= 0;
         end;
      end;
end;


procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i, j: integer;
   procedure SetPanelPos; // mremisteni panelu
   begin
     i:= X - Panel1.Width div 2;
     j:= Y - Panel1.Height div 2;
     if i < 0 then i:= 0 else
        if i > ClientWidth - Panel1.Width then
           i:= ClientWidth - Panel1.Width;
     if j < 0 then j:= 0 else
        if j > ClientHeight - Panel1.Height then
           j:= ClientHeight - Panel1.Height;
     Panel1.Left:= i;  Panel1.Top:= j;
   end;
begin
   case GState of
      0: begin // panel pred startem hry
         SetPanelPos;
         if not Panel1.Visible then begin // aktivace panelu
            BitBtn1.Hint:= msgRUN;
            Hint:= '';
            Label1.Caption:= msgCHPLAYER;
            Panel1.Visible:= TRUE;
            ActiveControl:= ComboBox1;
            end;
         end;
      2: begin // pauza
         SetPanelPos;
         if not Panel1.Visible then begin
            BitBtn1.Hint:= msgCONTINUE;
            ComboBox1.Enabled:= FALSE;
            BitBtn3.Enabled:= FALSE;
            Label1.Caption:= msgPAUSE;
            Panel1.Visible:= TRUE;
            ActiveControl:= BitBtn1;
            Timer1.Enabled:=FALSE;
            end;
         end;
      end; //case
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   case GState of
      0: if not Panel1.Visible then begin // panel na uvodni obrazek
         Panel1.Left:= (ClientWidth - Panel1.Width) div 2;
         Panel1.Top:= (ClientHeight - Panel1.Height) div 2;
         BitBtn1.Hint:= msgRUN;
         Hint:= '';
         Label1.Caption:= msgCHPLAYER;
         Panel1.Visible:= TRUE;
         ActiveControl:= ComboBox1;
         end;

      2: begin // stisk klavesy ve hre, nastavi dalsi pohyb
         case Key of
            27: Move:= eEXPL; // autodestrukce
            37: Move:= eMVL;  // vlevo
            38: Move:= eMVU;  // nahoru
            39: Move:= eMVR;  // vpravo
            40: Move:= eMVD;  // dolu
            80: if not Panel1.Visible then begin // pauza
                   Panel1.Left:= (ClientWidth - Panel1.Width) div 2;
                   Panel1.Top:= (ClientHeight - Panel1.Height) div 2;
                   BitBtn1.Hint:= msgCONTINUE;
                   ComboBox1.Enabled:= FALSE;
                   BitBtn3.Enabled:= FALSE;
                   Label1.Caption:= msgPAUSE;
                   Panel1.Visible:= TRUE;
                   ActiveControl:= BitBtn1;
                   Timer1.Enabled:=FALSE;
                   end;
            end;
         SuckUp:= ssSHift in Shift; // vysavani policek
         end;
      end; //case
end;

procedure TForm1.BitBtn2Click(Sender: TObject); // otevre HTML dokumentaci
begin
   ExecuteFile(fHELP, '', '', SW_SHOWNORMAL);
end;

end.
