{ hlavni jednotka  Boulder Mana }
unit BMbase;

interface
{$I BMCOMMIF.INC}

const
   MAXMVELEMS = (MAXMX - 2) * (MAXMY - 2) - 2;
   UnStabObjs : set of byte = [KAMEN, DIAMANT, TRHAVINA, ZEDN];

   { konstanty pro udalosti pohyblivych objektu }
   eNOTHING = 255;  { zadna }

   eINIT = 0;   { vytvoreni }
   eEXPL = 1;   { exploze }
   eDEXPL = 2;  { diamantova exploze }
   eFALLL = 3;  { padani vlevo }
   eFALLD = 4;  { padani dolu }
   eFALLR = 5;  { padani vpravo }
   eMVL = 6;    { pohyb vlevo }
   eMVR = 7;    { pohyb vpravo }
   eMVU = 8;    { pohyb nahoru }
   eMVD = 9;    { pohyb dolu }
   eLOCK = 10;  { uzamceni }
   eSUCK = 11;  { vysavani }

   { konstanty pro stav hrace }
   sMOVE = 0;     { provedeni pohybu }
   sNOMOVE = 1;   { odmitnuti pohybu }
   sPUSH = 2;     { tlaceni na rovine }
   sENDPUSH = 3;  { tlaceni na nestabilnim kraji }


type
   TMvElem = record  { prvek seznamu padajicich ojektu }
                X: byte;
                next: word;
                end;

   TPlayer = record PosX, PosY: byte;        { poloha hrace v mape }
                    KillEv: boolean;         { ? vybuch 3x3 }
                    Exist, SuckUp: boolean;  { priznak existence, vysavani }
                    DCnt: word;              { sebrany pocet diamantu }
                    end;

   TExit = record PosX, PosY: byte;
                  Exist: boolean;
                  DCnt: word;  { pozadovany koncovy pocet diamantu }
                  end;

   TMvGroup = record  { skupina pohyblivych objektu (seznamy indexovane podle
                        radku) }
                 Yindex: array [2..MAXMY - 1] of word;  { index radku }
                 last: array [2..MAXMY - 1] of word;
                 end;

   TReport = record { vypis o budoucich udalostech v mape }
                rDIAMSEBR,  { sebrani diamantu }
                rDIAMPAD,   { dopadnuti diamantu }
                rKAMENPAD,  { dopadnuti kamene }
                rVYBUCH,    { vybuch }
                rKONEC: boolean; { uspesny utek do vychodu }
                rHRACSTAV: byte; { stav: sMOVE/sNOMOVE/sPUSH/sNOPUSH }
                rZABITOP: word;  { pocet zabitych priser }
                end;

   TBMEvents = record EM: TMap;    { mapa udalosti }
                      R: TReport;  { vypis o udalostech }

                  P: TPlayer;  { hrac }
                  E: TExit;    { vychod }

                  { spolecna pamet pohyblivych objektu vsech skupin }
                  M: array [1..MAXMVELEMS] of TMvElem;
                  first: word;  { uk. na 1. volnou polozku }

                  { skupiny pohyblivych objektu pro rychle mapovani }
                  G: array [0..2] of TMvGroup;
                     { 0 padajici (kameny, diamanty, trhaviny), 1 prisery,
                       2 explodujici (vyjmute z 0 nebo 1) }
                  end;

procedure InitBMEvents(var BME: TBMEvents; var OM: TMap; DiamCnt: word);
procedure UpdateMap(var BME: TBMEvents; var OM: TMap);
procedure UpdateEvents(var BME: TBMEvents; var OM: TMap;
                       Move: byte; SuckUp: boolean);

procedure TestPrint(var BME: TBMEvents);


implementation

const
   { pomocne chybove konstanty }
   MvMemErr = 1;


procedure ERR(Err: byte);
{ vypis fatalnich chyb }
var S: string[6];
begin
   case Err of
      MvMemErr : S:= 'TMvMem';

      end;
  writeln('ERROR: Incorrect ', S, ' (BMbase) usage');
  halt(1);
end;



procedure TestPrint(var BME: TBMEvents);
{var i, j, k: word;}
begin
   with BME do begin
{      writeln;
      write('':5);  for j:= 1 to MAXMVELEMS do write(j:5); writeln;
      write('M:');  for j:= 1 to MAXMVELEMS do write(M[j].x:5); writeln;
      write(first:5); for j:= 1 to MAXMVELEMS do write(M[j].next:5); writeln;
}     writeln;
      writeln('P:e,x,y,d: ', P.Exist, ',', P.PosX, ',', P.PosY, ',', P.DCnt);
      writeln('E:e,x,y,d: ', E.Exist, ',', E.PosX, ',', E.PosY, ',', E.DCnt);
      writeln('R:DIAMSEBR,DIAMPAD,KAMENPAD,VYBUCH,',
              'KONEC,HRACSTAV,ZABPRISER');
      writeln(R.rDIAMSEBR:10, ',', R.rDIAMPAD:7, ',', R.rKAMENPAD:8, ',',
              R.rVYBUCH:6, ',', R.rKONEC:5, ',',
              R.rHRACSTAV:8, ',', R.rZABITOP:9);

{      for k:= 0 to 2 do
         for j:= 2 to BME.EM.SizeY - 1 do begin
            i:= G[k].Yindex[j];
            write(j,'(',G[k].last[j],'):');
            while i <> 0 do begin
               write(' ', M[i].X);
               i:= M[i].next;
               end;
            writeln;
            end;

{      for j:= 1 to EM.SizeY do begin
         for i:= 1 to EM.SizeX do write(EM.M[i,j]);
         writeln;
         end;
      writeln;
}     end;
end;



procedure InsMvObj(var BME: TBMEvents; var Gr: TMvGroup; X, Y: byte);
{ Vlozi zaznam o souradnicih objektu z pozice X, Y (rozsah se nekontroluje) do
  zadane skupiny objektu (na zacatek radku Y) do BME udalosti (G musi byt
  vytvorena v BME). }
var aux: word;
begin
   with BME do
      if first = 0 then ERR(MvMemErr)   { kontrola existence volne polozky }
      else begin
         aux:= M[first].next;           { uchovani uk. dalsi volne polozky }
         M[first].X:= X;                { zapis X }
         M[first].next:= Gr.Yindex[Y];  { pripoji polozku na zacatek }
         Gr.Yindex[Y]:= first;          { opravi uk. na 1. polozku radku Y }
         if Gr.last[Y] = 0 then         { opravi uk. posledniho }
            Gr.last[Y]:= first;
         first:= aux;                   { opravi uk. 1. volne polozky }
         end;
end;



procedure AddMvObj(var BME: TBMEvents; var Gr: TMvGroup; X, Y: byte);
{ Vlozi zaznam o souradnicich objektu z pozice X, Y (rozsah se nekontroluje)
  do zadane skupiny objektu (na konec radku Y) do BME udalosti (G musi byt
  vytvorena v BME). }
var aux: word;
begin
   with BME do
      if first = 0 then ERR(MvMemErr)   { kontrola existence volne polozky }
      else begin
         aux:= M[first].next;           { uchovani uk. dalsi volne polozky }
         M[first].X:= X;                { zapis X }
         M[first].next:= 0;             { korektne zakonci posledni prvek }
         if Gr.last[Y] = 0              { napoji prvek na seznam }
            then Gr.Yindex[Y]:= first
            else M[Gr.last[Y]].next:= first;
         Gr.last[Y]:= first;            { nastavi uk. posledniho na novy }
         first:= aux;                   { opravi uk. 1. volne polozky }
         end;
end;



procedure DelMvObjs(var BME: TBMEvents; var Gr: TMvGroup;
                    X1, Y1, X2, Y2, ExceptEv: byte);
{ Maze zaznam o souradnicich pohyblivych objektu v zadanem okne z dane skupiny
  z BME. Uvolnene plozky jsou pridany na zacatek spolecneho seznamu volnych
  polozek }
var j: byte;
    i, oldi, aux: word;
begin
   { kontrola rozsahu }
   if X1 < 2 then X1:= 2 else if X1 > MAXMX - 1 then X1:= MAXMX - 1;
   if X1 < 2 then X2:= 2 else if X2 > MAXMX - 1 then X2:= MAXMX - 1;
   if Y1 < 2 then Y1:= 2 else if Y1 > MAXMY - 1 then Y1:= MAXMY - 1;
   if Y2 < 2 then Y2:= 2 else if Y2 > MAXMY - 1 then Y2:= MAXMY - 1;
   with BME do
      for j:= Y1 to Y2 do begin                      { pres vybrane radky }
          oldi:= 0;                                  { nil-uje pomocny uk. }
          i:= Gr.Yindex[j];
          while i <> 0 do begin
             aux:= M[i].next;                        { uchova zbytek seznamu }
             if (M[i].X >= X1) and (M[i].X <= X2) and
                (EM.M[M[i].X, j] <> ExceptEv) then begin
                M[i].next:= first;                { napoji seznam volnych }
                first:= i;                        { opravi uk. na volne }
                { napoji uchovany zbytek seznamu }
                if oldi = 0 then Gr.Yindex[j]:= aux
                            else M[oldi].next:= aux;
                { osetri posledni prvek }
                if aux = 0 then Gr.last[j]:= oldi;
                end else oldi:= i;
             i:= aux;
             end;
          end;
end;



procedure ConcateGroups(var BME: TBMEvents; var G1, G2: TMvGroup);
{ Vyjme zadanou cast (cele radky) z G2 a pripoji ji na konec skupiny G1 v BME.
  G1 a G2 musi byt vytvorene ve stejne BME (pouze prepojeni ukazatelu).
  Rozsahy vstupu se nekontroluji. }
var j: byte;
begin
   with BME do
      for j:= 2 to EM.SizeY - 1 do begin  { prepoji radek po radku }
         if G1.last[j] = 0
            then G1.Yindex[j]:= G2.Yindex[j]
            else M[G1.last[j]].next:= G2.Yindex[j];
         if G2.last[j] <> 0 then G1.last[j]:= G2.last[j];
         G2.Yindex[j]:= 0;  { rusi odkazy NewG na zkopirovane radky }
         G2.last[j]:= 0;
         end;
end;



procedure InitMvGroup(var G: TMvGroup; EMSizeY: byte);
{ inicializace (vyprazneni) skupiny }
var j: byte;
begin
   for j:= 2 to EMSizeY - 1 do begin
      G.Yindex[j]:= 0;
      G.last[j]:= 0;
      end;
end;



procedure InitBMEvents(var BME: TBMEvents; var OM: TMap; DiamCnt: word);
{ Inicializace BME podle mapy objektu a vyhledani pohyblivych objektuy.
  DiamCnt nastavuje pocet diamatu, ktere maji byt sebrany (0 = autodetekce
  podle mapy objektu) }
var i, j, d: word;
begin
   with BME do begin
      EM.SizeX:= OM.SizeX;  EM.SizeY:= OM.SizeY; { zajisti stejne rozmery }

      { Inicializace mapy udalosti }
      for j:= 1 to EM.SizeY do
         for i:= 1 to EM.SizeX do EM.M[i,j]:= eNOTHING;

      { Inicializuje spolecnou pamet pamet pohyblivych objektu }
      for i:= 1 to MAXMVELEMS do M[i].next:= i - 1;  { pospojovani }
      first:= MAXMVELEMS;  { nastavi 1. volnou polozku }

      { Inicializace mapovacich skupin }
      for i:= 0 to 2 do InitMvGroup(G[i], EM.SizeY);

      {Inicializace nastaveni hrace a vychodu }
      P.DCnt:= 0;       { pocet sebranych diamantu }
      P.Exist:= FALSE;
      E.Exist:= FALSE;
      end;  {with}
   d:= 0; { init pocitadla diamantu v mape }

   { vyhledani objektu }
   with OM do
      for j:= 2 to SizeY - 1 do
         for i:= 2 to SizeX - 1 do begin
            case M[i, j] of

               TRHAVINA:
                  if (M[i, j + 1] = MEZERA) then begin       { pad dolu }
                     InsMvObj(BME, BME.G[0], i, j);
                     BME.EM.M[i, j]:= eFALLD;      { zapise udalost }
                     BME.EM.M[i, j + 1]:= eLOCK;   { oznaci mezeru udalosti }
                     end
                  else InsMvObj(BME, BME.G[0], i, j);

               KAMEN, DIAMANT: begin
                  if M[i, j] = DIAMANT then d:= d + 1;  { diamantu v mape }

                  if (M[i, j + 1] = MEZERA) then begin       { pad dolu }
                     InsMvObj(BME, BME.G[0], i, j);
                     BME.EM.M[i, j]:= eFALLD;
                     BME.EM.M[i, j + 1]:= eLOCK;
                     end else

                  if M[i, j + 1] in UnStabObjs then  { pad z nest. objektu }
                     if (M[i + 1, j] = MEZERA) and             { vpravo }
                        (M[i + 1, j + 1] = MEZERA) and
                        (BME.EM.M[i + 1, j] = eNOTHING) then begin
                           InsMvObj(BME, BME.G[0], i, j);
                           BME.EM.M[i, j]:= eFALLR;
                           BME.EM.M[i + 1, j]:= eLOCK;
                           BME.EM.M[i + 1, j + 1]:= eLOCK;
                           end else
                     if (M[i - 1, j] = MEZERA) and             { vlevo }
                        (M[i - 1, j + 1] = MEZERA) and
                        (BME.EM.M[i - 1, j] = eNOTHING) then begin
                           InsMvObj(BME, BME.G[0], i, j);
                           BME.EM.M[i, j]:= eFALLL;
                           BME.EM.M[i - 1, j]:= eLOCK;
                           BME.EM.M[i - 1, j + 1]:= eLOCK;
                           end
                     else InsMvObj(BME, BME.G[0], i, j)  { pad nikam }

                  else InsMvObj(BME, BME.G[0], i, j);
                  end;

               PRISERA: InsMvObj(BME, BME.G[1], i, j);

               HRAC: with BME do begin P.PosX:= i;
                                       P.PosY:= j;
                                       EM.M[i, j]:= eINIT;
                                       P.Exist:= TRUE;
                                       P.KillEv:= FALSE;
                                       end;
               VYCHOD: with BME do begin E.PosX:= i;
                                         E.PosY:= j;
                                         E.Exist:= TRUE;
                                         end;
               end;  {case}
            end;  {for}

   { nastaveni poctu diamantu a stavu VYCHODu }
   with BME do begin
      if DiamCnt = 0 then E.DCnt:= d          { pocet diamantu v mape }
                     else E.DCnt:= DiamCnt;   { pozadovany pocet diamantu }
      if E.Exist and (P.DCnt >= E.DCnt) then   { ? otevreni vychodu }
         EM.M[E.PosX, E.PosY]:= eINIT;

      R.rDIAMSEBR:= FALSE;  { inicializace zbytku vypisu }
      R.rDIAMPAD:= FALSE;
      R.rKAMENPAD:= FALSE;
      R.rVYBUCH:= FALSE;
      R.rKONEC:= FALSE;
      R.rHRACSTAV:= sMOVE;
      R.rZABITOP:= 0;
      end;
end;



procedure UpdateMap(var BME: TBMEvents; var OM: TMap);
{ Upravi data v mape objektu (presouva objekty a uvolnuje puvodni misto podle
  BME (vyuziva mapovani pres skupiny pohyblivych objektu) }

var j, k, x, a, b: byte;
    i, oldi, aux: word;
    auxG: array[0..1] of TMvGroup;

    procedure DelActItem;
    { pomocna pro smazani udalosti z radku skupiny }
    begin
       with BME do begin
          M[i].next:= first;              { napoji seznam volnych }
          first:= i;                      { opravi uk. na volne }
          if oldi = 0 then G[k].Yindex[j]:= aux  { napoji seznam }
                      else M[oldi].next:= aux;
          if aux = 0 then G[k].last[j]:= oldi;   { opravi posledni }
          end;
    end;

    procedure UnExplode3x3;
    { pomocna pro smazani exploze 3x3 (uvolneni mista) }
    var a, b: byte;
    begin
       with BME do for b:= j - 1 to j + 1 do
          for a:= x - 1 to x + 1 do
              if OM.M[a, b] = ZEDS then EM.M[a, b]:= eNOTHING  { odolne }
              else if OM.M[a, b] <> HRAC then  { hrac se maze zvast }
                 if EM.M[a, b] = eEXPL then begin
                    OM.M[a, b]:= MEZERA;
                    EM.M[a, b]:= eNOTHING;
                    end else
                 if EM.M[a, b] = eDEXPL then begin
                    OM.M[a, b]:= DIAMANT;
                    InsMvObj(BME, G[0], a, b);
                    EM.M[a, b]:= eNOTHING;
                    end;
    end;

begin
   with BME do begin
      for k:= 0 to 1 do begin
         InitMvGroup(auxG[k], EM.SizeY);
         for j:= 2 to EM.SizeY - 1 do begin
            oldi:= 0;
            i:= G[k].Yindex[j];
            while i <> 0 do begin
               aux:= M[i].next;
               x:= M[i].X;

               { horizontalni pohyb }
               if (EM.M[x, j] = eMVL) or (EM.M[x, j] = eMVR) then begin
                  case EM.M[x, j] of
                     eMVL: begin           { pohyb vlevo }
                        M[i].X:= M[i].X - 1;          { oprava ve skupine }
                        OM.M[x - 1, j]:= OM.M[x, j];  { presun objektu }
                        EM.M[x - 1, j]:= EM.M[x, j];  { presun udalosti }
                        OM.M[x, j]:= MEZERA;          { smazani puvodnich }
                        EM.M[x, j]:= eNOTHING;
                        end;
                     eMVR: begin           { pohyb vpravo }
                        M[i].X:= M[i].X + 1;
                        OM.M[x + 1, j]:= OM.M[x, j];
                        EM.M[x + 1, j]:= EM.M[x, j];
                        OM.M[x, j]:= MEZERA;
                        EM.M[x, j]:= eNOTHING;
                        end;
                     end;  {case}
                  oldi:= i;
                  end
               { vert. pohyb (vymazani z radku a vlozeni do jineho) }
               else case EM.M[x, j] of
                       eMVU: begin  { pohyb nahoru }
                          DelActItem;
                          InsMvObj(BME, auxG[k], x, j - 1);
                          OM.M[x, j - 1]:= OM.M[x, j];
                          EM.M[x, j - 1]:= eMVU;
                          OM.M[x, j]:= MEZERA;
                          EM.M[x, j]:= eNOTHING;
                          end;
                       eMVD: begin  { pohyb dolu }
                          DelActItem;
                          InsMvObj(BME, auxG[k], x, j + 1);
                          OM.M[x, j + 1]:= OM.M[x, j];
                          EM.M[x, j + 1]:= eMVD;
                          OM.M[x, j]:= MEZERA;
                          EM.M[x, j]:= eNOTHING;
                          end;
                       eFALLD: begin                    { pad dolu }
                          DelActItem;
                          InsMvObj(BME, auxG[k], x, j + 1);
                          OM.M[x, j + 1]:= OM.M[x, j];
                          EM.M[x, j + 1]:= eFALLD;
                          OM.M[x, j]:= MEZERA;
                          EM.M[x, j]:= eNOTHING;
                          end;
                       eFALLR: begin                    { pad vpravo }
                          DelActItem;
                          InsMvObj(BME, auxG[k], x + 1, j + 1);
                          OM.M[x + 1, j + 1]:= OM.M[x, j];
                          EM.M[x + 1, j + 1]:= eFALLD;
                          OM.M[x, j]:= MEZERA;
                          EM.M[x, j]:= eNOTHING;
                          EM.M[x + 1, j]:= eNOTHING;
                          end;
                       eFALLL: begin                    { pad vlevo }
                          DelActItem;
                          InsMvObj(BME, auxG[k], x - 1, j + 1);
                          OM.M[x - 1, j + 1]:= OM.M[x, j];
                          EM.M[x - 1, j + 1]:= eFALLD;
                          OM.M[x, j]:= MEZERA;
                          EM.M[x, j]:= eNOTHING;
                          EM.M[x - 1, j]:= eNOTHING;
                          end;
                       else oldi:= i;
                       end;  {case}

               i:= aux;
               end;  {while}
            end;  {for j}
         ConcateGroups(BME, BME.G[k], auxG[k]);
         end; {for k}

      { maze exploze podle skupiny explodujicich objektu }
      for j:= 2 to EM.SizeY - 1 do begin
         i:= G[2].Yindex[j];
         while i <> 0 do begin
            aux:= M[i].next;
            x:= M[i].X;
            { vzdy polozku (skupiny explozi) hned smaze (1. prvek) }
            M[i].next:= first;                  { napoji seznam volnych }
            first:= i;                          { opravi uk. na volne }
            G[2].Yindex[j]:= aux;               { napoji seznam }
            if aux = 0 then G[2].last[j]:= 0;   { opravi posledni }
            i:= aux;
            UnExplode3x3;
            end;  {while}
         end;  {for j}

      { zpracuje hrace }
      if P.Exist then begin
         a:= P.PosX;  b:= P.PosY;
         case EM.M[P.PosX, P.PosY] of  { zjisti novou pozici }
            eMVL: a:= P.PosX - 1;
            eMVR: a:= P.PosX + 1;
            eMVU: b:= P.PosY - 1;
            eMVD: b:= P.PosY + 1;
            eINIT: begin if P.KillEv then OM.M[a, b]:= MEZERA;
                         EM.M[a, b]:= eNOTHING;
                         end;
            eEXPL: begin x:= a;  j:= b;
                         if P.KillEv then UnExplode3x3; { maze okoli }
                         OM.M[a, b]:= MEZERA;           { maze hrace }
                         EM.M[a, b]:= eNOTHING;
                         end;
            eDEXPL: begin x:= a;  j:= b;
                          if P.KillEv then UnExplode3x3; { maze okoli }
                          OM.M[a, b]:= DIAMANT;          { vklada diamant }
                          InsMvObj(BME, G[0], a, b);
                          EM.M[a, b]:= eNOTHING;
                          end;
            end;  {case}
         if (EM.M[P.PosX, P.PosY] = eMVL) or (EM.M[P.PosX, P.PosY] = eMVR) or
            (EM.M[P.PosX, P.PosY] = eMVU) or (EM.M[P.PosX, P.PosY] = eMVD)
            then begin
            if OM.M[a, b] = DIAMANT then begin  { rusi diamant }
               DelMvObjs(BME, G[0], a, b, a, b, eINIT);
               P.DCnt:= P.DCnt + 1;
               if E.Exist and (P.DCnt >= E.DCnt) then  { otevreni vychodu }
                  EM.M[E.PosX, E.PosY]:= eINIT
               end;
            if P.SuckUp then begin   { vysati }
               OM.M[a, b]:= MEZERA;  { maze vedle }
               EM.M[a, b]:= eNOTHING;
               end
            else begin
               OM.M[a, b]:= OM.M[P.PosX, P.PosY];  { hrac na novou pozici }
               EM.M[a, b]:= EM.M[P.PosX, P.PosY];  { kopie udalosti }
               OM.M[P.PosX, P.PosY]:= MEZERA;      { obnovi puvodni misto }
               EM.M[P.PosX, P.PosY]:= eNOTHING;    { rusi na stare pozici }
               P.PosX:= a; P.PosY:= b;             { opravi pozici hrace }
               end;
            end;
         P.Exist:= OM.M[P.PosX, P.PosY] = HRAC;
         end;  {if P.Exist}

     { kontroluje existenci vychodu }
     E.Exist:= OM.M[E.PosX, E.PosY] = VYCHOD;
     end;  {with}
end;



procedure ExplodeObjs(var BME: TBMEvents; var OM: TMap);
{ Provede spravnou poslopnost vybuchu podle BME. }
var j, k, x: byte;
    i, oldi, aux: word;

    procedure DelActItem;
    { pomocna pro smazani udalosti z radku skupiny }
    begin
       with BME do begin
          M[i].next:= first;              { napoji seznam volnych }
          first:= i;                      { opravi uk. na volne }
          if oldi = 0 then G[k].Yindex[j]:= aux  { napoji seznam }
                      else M[oldi].next:= aux;
          if aux = 0 then G[k].last[j]:= oldi;   { opravi posledni }
          end;
    end;

    procedure Explode3x3;
    { pomocna pro oznaceni (diamantoveho) vybuchu a smazani objektu (3x3) }
    var a, b: byte;
    begin
       with BME do
          for b:= j - 1 to j + 1 do
             for a:= x - 1 to x + 1 do  { neprepisuje uz explodujici }
                if (EM.M[a, b] <> eEXPL) and (EM.M[a, b] <> eDEXPL) then

                   if (OM.M[a, b] = TRHAVINA) and ((a <> x) or (b <> j))
                      then EM.M[a, b]:= eINIT  { postupna exploze trhavin }
                      else begin EM.M[a, b]:= EM.M[x, j];
                                 if OM.M[a, b] = PRISERA then { vypis }
                                    R.rZABITOP:= R.rZABITOP + 1;
                                 end;
       { smaze pohyblive objekty v okoli vybuchu (3x3) }
       DelMvObjs(BME, BME.G[0], x - 1, j - 1, x + 1, j + 1, eINIT);
       DelMvObjs(BME, BME.G[1], x - 1, j - 1, x + 1, j + 1, eINIT);
       BME.R.rVYBUCH:= TRUE;  { vypis }
    end;

    function FallExplode(x, y: byte): boolean;
    { Zabranuje uhaseni (eNOTHING) padajici trhaviny pri dopadu na vybuch.
      Testeje tri policka na explozi o dva radky niz (ve skupine explozi) }
    var i: word;  found: boolean;
    begin
       found:= FALSE;
       with BME do if y + 2 < EM.SizeY then begin
          i:= G[2].Yindex[y + 2];
          while (i <> 0) and not found do begin
             found:= (x - 1 = M[i].X) or (x = M[i].X) or (x + 1 = M[i].X);
             i:= M[i].next;
             end;
          end;
       FallExplode:= found;
    end;

begin
   with BME do begin
      for k:= 0 to 1 do begin
         { vyhledani explodujicich objektu ve skupinach pohyblivych objektu }
         for j:= EM.SizeY - 1 downto 2 do begin  { zdola }
            oldi:= 0;
            i:= G[k].Yindex[j];
            while i <> 0 do begin
               aux:= M[i].next;
               x:= M[i].X;
               case OM.M[x, j] of

                  TRHAVINA:
                     if ((EM.M[x, j] = eFALLD) and
                         ((OM.M[x, j + 1] <> MEZERA) or FallExplode(x,j))) or
                        (EM.M[x, j] = eINIT) then begin
                        DelActItem;
                        InsMvObj(BME, G[2], x, j);  { vlozi explozi }
                        EM.M[x, j]:= eEXPL;
                        end
                     else oldi:= i;

                  KAMEN, DIAMANT: begin
                     if (EM.M[x, j] = eFALLD) then
                        if (OM.M[x, j + 1] = PRISERA) then
                           EM.M[x, j + 1]:= eDEXPL else
                        {if (OM.M[x, j + 1] = TRHAVINA) then
                           EM.M[x, j + 1]:= eINIT else}
                        if (OM.M[x, j + 1] = HRAC) then begin
                           EM.M[x, j + 1]:= eDEXPL;
                           P.KillEv:= TRUE;
                           end;
                     oldi:= i;
                     end;

                  PRISERA:
                     if EM.M[x, j] = eDEXPL then begin
                        DelActItem;
                        AddMvObj(BME, G[2], x, j);
                        end else
                     if (OM.M[x - 1, j] = HRAC) or (OM.M[x + 1, j] = HRAC) or
                        (OM.M[x, j - 1] = HRAC) or (OM.M[x, j + 1] = HRAC)
                        then begin EM.M[x, j]:= eEXPL;
                                   DelActItem;
                                   AddMvObj(BME, G[2], x, j);
                                   end
                     else oldi:= i;

                  else oldi:= i;

                  end;  {case}
               i:= aux;
               end;  {while}
            end;  {for j}
         end; {for k}

      { vytvari vybuchy podle skupiny exlpodujicich objektu }
      for j:= EM.SizeY - 1 downto 2 do begin
         i:= G[2].Yindex[j];
         while i <> 0 do begin x:= M[i].X;
                               i:= M[i].next;
                               Explode3x3;
                               end;
         end;  {for j}

      { vybuch HRACe (po primem zasahu KAMENem nebo DIAMANTem) }
      if P.Exist then begin
        x:= P.PosX;  j:= P.PosY;
        if P.KillEv then Explode3x3;
        end;

      end;  {with}
end;



procedure CheckPlayerMove(var BME: TBMEvents; var OM: TMap;
                          var Move: byte; var SuckUp: boolean);
{ Provede nebo zrusi pohyb hrace, aby nedoslo ke kolizi objektu (coz take
  napriklad zabrani vejit do exploze, pod padajici kamen, atd. ). }
var x, y: byte;
    i, j: shortint;
begin
   with BME do if P.Exist then begin
      x:= P.PosX;  y:= P.PosY;
      if (EM.M[x, y] <> eEXPL) and (EM.M[x, y] <> eDEXPL) then begin

         EM.M[P.PosX, P.PosY]:= Move;
         P.SuckUp:= SuckUp;

         i:= 0;  j:= 0;
         case EM.M[x, y] of eMVL: i:= -1;
                            eMVR: i:= +1;
                            eMVU: j:= -1;
                            eMVD: j:= +1;
                            end;
         x:= x + i;  y:= y + j;
         case OM.M[x, y] of
            KAMEN, TRHAVINA:
               if j = 0 then  { testuj pro horzontalni pohyb (posun) }
                  { tlaceni na rovine }
                  if (EM.M[x, y] = eNOTHING) and        { ? ma udalost }
                     (OM.M[x + i, y + j] = MEZERA) and  { ? za nim volno }
                     (EM.M[x + i, y + j] = eNOTHING) then begin
                     EM.M[x + i, y + j]:= eLOCK;
                     EM.M[x, y]:= EM.M[P.PosX, P.PosY];
                     R.rHRACSTAV:= sPUSH;
                     end else
                  { tlaceni na konci nestabilni roviny }
                  if (EM.M[x, y] = eFALLL) or (EM.M[x, y] = eFALLR) then
                     R.rHRACSTAV:= sENDPUSH
                  { nejde odtlacit }
                  else begin R.rHRACSTAV:= sPUSH;
                             EM.M[P.PosX, P.PosY]:= eNOTHING;
                             end
               else begin R.rHRACSTAV:= sNOMOVE;
                          EM.M[P.PosX, P.PosY]:= eNOTHING
                          end;

            MEZERA: if EM.M[x, y] <> eNOTHING then begin
                       R.rHRACSTAV:= sNOMOVE;
                       EM.M[P.PosX, P.PosY]:= eNOTHING;
                       end else EM.M[x,y]:= eLOCK; { sezrani }

            TRAVA: if EM.M[x, y] <> eNOTHING then begin
                      R.rHRACSTAV:= sNOMOVE;
                      EM.M[P.PosX, P.PosY]:= eNOTHING;
                      end else EM.M[x,y]:= eSUCK; { sezrani }

            DIAMANT: if EM.M[x, y] = eNOTHING then begin
                        R.rDIAMSEBR:= TRUE;
                        EM.M[x, y]:= eSUCK;  { sezrani }
                        end else begin R.rHRACSTAV:= sNOMOVE;
                                       EM.M[P.PosX, P.PosY]:= eNOTHING;
                                       end;

            VYCHOD: if EM.M[x, y] = eINIT then begin
                       R.rKONEC:= TRUE;
                       P.KillEv:= TRUE;
                       EM.M[P.PosX, P.PosY]:= eINIT;
                       end
                    else begin R.rHRACSTAV:= sNOMOVE;
                               EM.M[P.PosX, P.PosY]:= eNOTHING;
                               end;

            HRAC : ;

            else begin R.rHRACSTAV:= sNOMOVE;  { tlaceni do zdi }
                       EM.M[P.PosX, P.PosY]:= eNOTHING;
                       end;
            end;  {case}
         end
      end;
end;



procedure EnemyMove(X, Y: byte; var OM: TMap; var BME: TBMEvents);
{ Voli dalsi pohyb prisery, podle toho, odkud prisla }
const { priority pro dalsi pohyb (0-3) }
      xyL: array[0..3, 0..2] of shortint =
         ((-1, 0, eMVL), (0, -1, eMVU), (0, +1, eMVD), (+1, 0, eMVR));
      xyR: array[0..3, 0..2] of shortint =
         ((+1, 0, eMVR), (0, -1, eMVU), (0, +1, eMVD), (-1, 0, eMVL));
      xyU: array[0..3, 0..2] of shortint =
         ((0, -1, eMVU), (-1, 0, eMVL), (+1, 0, eMVR), (0, +1, eMVD));
      xyD: array[0..3, 0..2] of shortint =
         ((0, +1, eMVD), (-1, 0, eMVL), (+1, 0, eMVR), (0, -1, eMVU));
var i, j, n, ev: byte;  b: boolean;
begin
   with BME do begin
      n:= 0;
      repeat
      case EM.M[X, Y] of  { hleda v danem smeru }
         eMVL: begin i:= X + xyL[n, 0]; j:= Y + xyL[n, 1]; ev:= xyL[n, 2] end;
         eMVR: begin i:= X + xyR[n, 0]; j:= Y + xyR[n, 1]; ev:= xyR[n, 2] end;
         eMVU: begin i:= X + xyU[n, 0]; j:= Y + xyU[n, 1]; ev:= xyU[n, 2] end;
          else begin i:= X + xyD[n, 0]; j:= Y + xyD[n, 1]; ev:= xyD[n, 2] end;
         end;
      b:= (EM.M[i, j] = eNOTHING) and (OM.M[i, j] = MEZERA);
      n:= n + 1;
      until b or (n = 4);
      if b then begin EM.M[X, Y]:= ev;
                      EM.M[i, j]:= eLOCK;
                      end
           else EM.M[X, Y]:= eNOTHING;
      end  {with}
end;



procedure UpdateEvents(var BME: TBMEvents; var OM: TMap;
                       Move: byte; SuckUp: boolean);
{ Urci nove udalosti podle skupin pohyblivych objektu. }
var j, k, x: byte;
    i: word;
begin
   with BME do begin
      R.rDIAMSEBR:= FALSE;  { inicializace vypisu }
      R.rDIAMPAD:= FALSE;
      R.rKAMENPAD:= FALSE;
      R.rVYBUCH:= FALSE;
      R.rHRACSTAV:= sMOVE;
      R.rZABITOP:= 0;

      if (Move = eEXPL) and P.Exist then begin  { autodestrukce hrace }
         EM.M[P.PosX, P.PosY]:= eEXPL;
         P.KillEv:= TRUE;
         end;
      ExplodeObjs(BME, OM);  { exloze objektu }

      { pohyb kamenu a priser  }
      for k:= 0 to 1 do
         for j:= 2 to EM.SizeY - 1 do begin
            i:= G[k].Yindex[j];
            while i <> 0 do begin
               x:= M[i].X;
               case OM.M[x, j] of

                  TRHAVINA: if EM.M[x, j] <> eINIT then

                     if (OM.M[x, j + 1] = MEZERA) and          { pad dolu }
                        (EM.M[x, j + 1] = eNOTHING) then begin
                        EM.M[x, j]:= eFALLD;
                        EM.M[x, j + 1]:= eLOCK;
                        end
                     else EM.M[x, j]:= eNOTHING;

                  KAMEN, DIAMANT: if (EM.M[x, j] <> eEXPL) and
                                     (EM.M[x, j] <> eDEXPL) then

                     if (OM.M[x, j + 1] = MEZERA) and          { pad dolu }
                        (EM.M[x, j + 1] = eNOTHING) then begin
                        EM.M[x, j]:= eFALLD;
                        EM.M[x, j + 1]:= eLOCK;
                        end else

                     if OM.M[x, j + 1] in UnStabObjs then  { z nest. objektu }
                        if (OM.M[x + 1, j] = MEZERA) and            { vpravo }
                           (OM.M[x + 1, j + 1] = MEZERA) and
                           (EM.M[x + 1, j] = eNOTHING) and
                           (EM.M[x + 1, j + 1] = eNOTHING) then begin
                           EM.M[x, j]:= eFALLR;
                           EM.M[x + 1, j]:= eLOCK;
                           EM.M[x + 1, j + 1]:= eLOCK;
                           end else
                        if (OM.M[x - 1, j] = MEZERA) and             { vlevo }
                           (OM.M[x - 1, j + 1] = MEZERA) and
                           (EM.M[x - 1, j] = eNOTHING) and
                           (EM.M[x - 1, j + 1] = eNOTHING) then begin
                           EM.M[x, j]:= eFALLL;
                           EM.M[x - 1, j]:= eLOCK;
                           EM.M[x - 1, j + 1]:= eLOCK;
                           end
                        else begin if EM.M[x, j] = eFALLD then  { vypis }
                                      if OM.M[x, j] = DIAMANT
                                         then R.rDIAMPAD:= TRUE
                                         else R.rKAMENPAD:= TRUE;
                                   EM.M[x, j]:= eNOTHING  { pad nikam }
                                   end

                     else begin if EM.M[x, j] = eFALLD then  { vypis }
                                   if OM.M[x, j] = DIAMANT
                                      then R.rDIAMPAD:= TRUE
                                      else R.rKAMENPAD:= TRUE;
                                EM.M[x, j]:= eNOTHING;  { rusi pohyb }
                                end;

                  PRISERA: if (EM.M[x, j] <> eEXPL) and
                              (EM.M[x, j] <> eDEXPL) then
                              EnemyMove(x, j, OM, BME);
                  end;  {case}

               i:= M[i].next;
               end;  {while}
            end;  {for j}

      { pohyb hrace }
      CheckPlayerMove(BME, OM, Move, SuckUp);
      end;  {with}
end;



end.
