unit LipCrt;

interface

const
   { konstanty pro specialni klavesy (pro SKeyPressed) }
   kRShift = 1;    { pravy Shift }
   kLShift = 2;    { levy Shift }
   kCtrl = 4;      { Ctrl }
   kAlt =  8;      { Alt }
   kScrLck = 16;   { Scroll Lock }
   kNumLck = 32;   { Num Lock }
   kCpsLck = 64;   { Caps Lock }

   { konstanty pro specialni znaky (pro GetChar) }
   kBSpc = 8;     { BackSpace }
   kTab = 9;      { Tab }
   kEnt = 13;     { Enter }
   kEsc = 27;     { Escape }
   kSpc = 32;     { mezera }
   kF1 = -59;     { F1 }
   kF2 = -60;     { F2 }
   kF3 = -61;     { F3 }
   kF4 = -62;     { F4 }
   kF5 = -63;     { F5 }
   kF6 = -64;     { F6 }
   kF7 = -65;     { F7 }
   kF8 = -66;     { F8 }
   kF9 = -67;     { F9 }
   kF10 = -68;    { F10 }
   kHome = -71;   { Home }
   kEnd = -79;    { End }
   kIns = -82;    { Insert }
   kDel = -83;    { Delete }
   kPgUp = -73;   { Page Up }
   kPgDn = -81;   { Page Down }
   kUp = -72;     { sipka nahoru }
   kDown = -80;   { sipka dolu }
   kLeft = -75;   { sipka vlevo }
   kRight = -77;  { sipka vpravo }
   kNoKey = 256;  { nic }

   { konstanty pro vzhled kurzoru }
   cFull = 0;     { cely znak (insert mode) }
   cHalf = 28;    { polovicni znak }
   cThick = 29;   { tlusty normalni }
   cNormal = 30;  { normalni kurzor }
   cThin = 31;    { tenky normalni }



procedure COn(Mode: byte);  { ASM }
procedure COff;  { ASM }

procedure FlushKeys;  { DMA }
procedure GetChar(var c: integer);
function SKeyPressed(SKeyComb: byte): boolean;  { DMA }



implementation

uses crt;

procedure COn;
{ zobrazi kurzor }
begin
   asm mov ah, 1
       mov cl, 1Fh
       mov ch, Mode
       int 10h
       end;
end;

procedure COff;
{ skryje kurzor }
begin
   asm mov ah, 1
       mov ch, 20h
       int 10h
       end;
end;

procedure FlushKeys;
{ Vyprazdni frontu znaku (zapise do zacatku konec) }
begin
   Mem[0:$041A]:= Mem[0:$041C];
end;


procedure GetChar(var c: integer);
{ Cte znaky z fronty. Pokud nacte jednoduchy znak, vrati v c jeho ordinalni
  hodnotu, pokud dvojznak, vrati zapornou ordinalni hodnotu druhe casti
  (viz. konstanty). Je-li fronta prazdna (nebyla stisknuta zadna klavesa)
  vrati v c kNoKey }
var aux: char;
begin
   if KeyPressed then begin
      aux:= ReadKey;
      if KeyPressed and (aux = #0) then begin
         aux:= ReadKey;
         c:= -ord(aux);
         end
      else c:=ord(aux);
      end
   else c:= kNoKey;
end;


function SKeyPressed(SKeyComb: byte): boolean;
{ Funkce vraci TRUE, pokud je zadana kombinace specialnich klaves
  (SKeyComb = soucet konstant) stisknuta nebo je aktivni. }
begin
   SKeyPressed:= Mem[0:$0417] and SKeyComb = SKeyComb;
end;



end.