{ test jednotky BMBASE (predelany Editor map) }

uses crt, LipCrt, BMbase,
     VMFiles;  { nacitani bytu po blocich pres vyrovnavaci pamet (VP) }

{$I BMCOMMIM.INC}

type TEditChar = record c : char;  col: byte; end;
const
   TITLE = 'Test jednotky BMbase';
   EArr: array [1..LastObj] of TEditChar = (
      (c : #32;  col: 7),   { MEZERA }
      (c : #177; col: 10),  { TRAVA }
      (c : #219; col: 6),   { ZEDS }
      (c : #178; col: 6),   { ZEDN }
      (c : #69;  col: 15),  { VYCHOD }
      (c : #4;   col: 12),  { KAMEN }
      (c : #4;   col: 11),  { DIAMANT }
      (c : #254; col: 14),  { TRHAVINA }
      (c : #1;   col: 15),  { HRAC }
      (c : #2;   col: 9));  { PRISERA }

procedure PrintInfo(X, Y: byte);
{ Tiskne popis ovladani }
begin
   textattr:= 7;
   gotoxy(X + 1, Y + 1);  write('<Sipky>  - Pohyb hrace');
   gotoxy(X + 1, Y + 2);  write('<Space>  - Hrac stoji');
   gotoxy(X + 1, Y + 3);  write('<Enter>  - Autodestrukce');
   gotoxy(X + 1, Y + 4);  write('<Escape> - Konec');
end;


procedure PrintMap(X, Y: byte; var M: TMap; var BME: TBMEvents);
{ Tiskne celou mapu i s udalostmi }
var i, j: byte;
begin
   textattr:= 7;  clrscr;
   textattr:= 31; write('':80);  gotoxy(1, 1);
   write(TITLE, ' (', ParamStr(1), ')');
   PrintInfo(X + M.SizeX + 2, Y);

   for j:= 1 to M.SizeY do begin
      gotoxy(X + 1, Y + j);
      for i:= 1 to M.SizeX do begin
         if (BME.EM.M[i, j] = eEXPL) then textattr:= 93 else
         if (BME.EM.M[i, j] = eDEXPL) then textattr:= 25 else
         if (BME.EM.M[i, j] = eINIT) then textattr:= 127
         else textattr:= EArr[M.M[i, j]].col;
         write(EArr[M.M[i, j]].c);
         end; {for i}
      end;
   for j:= 1 to BME.EM.SizeY do begin
      gotoxy(X + 1, Y + j + M.SizeY);
      for i:= 1 to BME.EM.SizeX do
         case BME.EM.M[i, j] of
            eNOTHING: begin textattr:= 8;  write(#250); end;
            eLOCK   : begin textattr:= 7;  write(#250); end;
            eSUCK   : begin textattr:= 7;  write('+'); end;
            else      begin textattr:= 7; write(BME.EM.M[i,j]); end;
         end;
      end;
   textattr:= 7; writeln;
   TestPrint(BME);
end;




procedure PrintHelp;
{ Vypisuje uvodni napovedu }
begin
   writeln; writeln(TITLE);
   writeln('Parametry: soubor');
   writeln('  soubor - umisteni a nazev souboru s mapou');
   writeln;
end;


var Map : TMap;
    lm: word;
    mv: byte;
    c, time: integer;
    BME: TBMEvents;


begin
   time:= 250;
   VFInit;  { inicializace VP }
   if ParamCount = 0 then PrintHelp else
      if LoadMap(ParamStr(1), Map) = LMNoErr then begin   { nahraje mapu }
         lm:= LastMode;  TextMode(CO80 + Font8x8); COff;  { mod 80x50 }

         InitBMEvents(BME, Map, 0);
          PrintMap(3, 3, Map, BME);  delay(time);

         UpdateMap(BME, Map);
          PrintMap(3, 3, Map, BME);

         repeat                         { ovladaci cyklus }
         GetChar(c);
         if c <> kNoKey then begin

            case c of
               kLeft: mv:= eMVL;
               kRight: mv:= eMVR;
               kUp: mv:= eMVU;
               kDown: mv:= eMVD;
               kEnt: mv:= eEXPL;
               kSpc: mv:= eNOTHING;
               end;
             UpdateEvents(BME, Map, mv, SKeyPressed(kLShift));
             PrintMap(3, 3, Map, BME);  delay(time);


            UpdateMap(BME, Map);
             PrintMap(3, 3, Map, BME);


            end;  {if}
         until c = kEsc;

         COn(cNormal);
         TextMode(lm);
         end else writeln('Chybna mapa');
end.
